package org.gcube.portlets.user.td.widgetcommonevent.shared.tr.column;

/**
 * 
 * @author "Giancarlo Panichi" <a
 *         href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a>
 * 
 */
public enum ColumnTypeCode {
	ANNOTATION("ANNOTATION"), ATTRIBUTE("ATTRIBUTE"), CODE("CODE"), CODEDESCRIPTION(
			"CODEDESCRIPTION"), CODENAME("CODENAME"), DIMENSION("DIMENSION"), MEASURE(
			"MEASURE"), TIMEDIMENSION("TIMEDIMENSION");

	/**
	 * @param text
	 */
	private ColumnTypeCode(final String id) {
		this.id = id;
	}

	private final String id;

	@Override
	public String toString() {
		return id;
	}

	public String getColumnTypeCodeLabel() {
		switch (this) {
		case ANNOTATION:
			return "Annotation";
		case ATTRIBUTE:
			return "Attribute";
		case CODE:
			return "Code";
		case CODEDESCRIPTION:
			return "Code Description";
		case CODENAME:
			return "Code Name";
		case DIMENSION:
			return "Dimension";
		case MEASURE:
			return "Measure";
		case TIMEDIMENSION:
			return "Time Dimension";
		default:
			return null;
		}

	}

	public static ColumnTypeCode getColumnTypeCodeFromId(String id) {
		if (id.compareTo(ANNOTATION.id) == 0) {
			return ANNOTATION;
		} else {
			if (id.compareTo(ATTRIBUTE.id) == 0) {
				return ATTRIBUTE;
			} else {
				if (id.compareTo(CODE.id) == 0) {
					return CODE;
				} else {
					if (id.compareTo(CODEDESCRIPTION.id) == 0) {
						return CODEDESCRIPTION;
					} else {
						if (id.compareTo(CODENAME.id) == 0) {
							return CODENAME;
						} else {
							if (id.compareTo(DIMENSION.id) == 0) {
								return DIMENSION;
							} else {
								if (id.compareTo(MEASURE.id) == 0) {
									return MEASURE;
								} else {
									if (id.compareTo(TIMEDIMENSION.id) == 0) {
										return TIMEDIMENSION;
									} else {
										return null;
									}
								}
							}
						}
					}
				}
			}
		}
	}

}
